// THIS CODE IS NOT USED ACTUALLY
// v 0 (21.10.02): initial release
#include <math.h>
#include "Polygon.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
POLYGON::POLYGON()
{
}

POLYGON::POLYGON( Vec3 dc1, Vec3 dc2, Vec3 dc3 )
{
    c1 = dc1;
    c2 = dc2;
    c3 = dc3;


    Normal = ((c1 - c2) ^ (c1 - c3)).GetNormalized();

    Vec3 up(1,0,0);
    PolygonHorisontal = (Normal ^ up).Normalize();
    PolygonVertical = (PolygonHorisontal ^ Normal).Normalize();

}

POLYGON::~POLYGON()
{
}

GLvoid POLYGON::Show()
{
	#if 0
    glBegin(GL_LINES);
    glVertex3f(c1.x, c1.y, c1.z);
    glVertex3f(c1.x+Normal.x, c1.y+Normal.y, c1.z+Normal.z);
    glEnd();

    glBegin(GL_TRIANGLES);
    glNormal3d(Normal.x, Normal.y, Normal.z);
    glTexCoord2d( 0.0, 0.0 );
    glVertex3d( c1.x, c1.y, c1.z );
    glTexCoord2d( 1.0, 0.0 );
    glVertex3d( c2.x, c2.y, c2.z );
    glTexCoord2d( 1.0, 1.0 );
    glVertex3d( c3.x, c3.y, c3.z );
    glEnd();
#endif
}

Vec3 POLYGON::GetNormal()
{/**/
    Vec3 v1 = c1 - c2;
    Vec3 v2 = c1 - c3;

    Normal = (v1 ^ v2).GetNormalized();
    return Normal;
}



bool POLYGON::InBorders(Vec3 point)
{
    Vec3 Rays[3];
    Rays[0] = (point - c1).GetNormalized();
    Rays[1] = (point - c2).GetNormalized();
    Rays[2] = (point - c3).GetNormalized();

    float TotalSum = 0;
    for(int i=0; i<2; i++)
        TotalSum += acosf(Rays[i] | Rays[i+1]);

    TotalSum += acos(Rays[0] | Rays[2]);

    if((TotalSum - F_PI2) > 0.00001f)
        return true;

    return false;
}

bool POLYGON::GetIntersect(Vec3 *IntersectPoint, GLfloat *Ratio, Vec3 Start, Vec3 End)
{
    Vec3 InterPoint;

    Vec3 L1 = Start - c1;
    Vec3 L2 = Start - End;

    Vec3 N = GetNormal();

    float K = (L1 | N) / (L2 | N);

    if( 0.0f <= K && K <= 1.0f )
    {
        InterPoint = Start - L2 * K;

        if( InBorders(InterPoint) )
        {
            IntersectPoint->x = InterPoint.x;
            IntersectPoint->y = InterPoint.y;
            IntersectPoint->z = InterPoint.z;
            Ratio = &K;

            return true;
        }
    }

    return false;
}

Vec3 POLYGON::GetReflectedDirection(Vec3 Direction)
{
    Vec3 N = GetNormal();

    return N*2.0f*(N | -Direction) + Direction;

}
