// v 0 (21.10.02): initial release
#ifndef POLYGONH
#define POLYGONH

#include <GL/gl.h>

#include "vec3.h"



class POLYGON
{
public:
    Vec3	c1;
    Vec3	c2;
    Vec3	c3;

    Vec3 Normal;
    Vec3 PolygonHorisontal;
    Vec3 PolygonVertical;

public:
    Vec3 GetReflectedDirection( Vec3 Direction);
    bool GetIntersect(Vec3 *IntersectPoint, GLfloat *Ratio, Vec3 Start, Vec3 End);
    bool InBorders(Vec3 point);
    Vec3 GetNormal();
    GLvoid Show();
    POLYGON();
    POLYGON( Vec3 dc1, Vec3 dc2, Vec3 dc3 );
    virtual ~POLYGON();

};

#endif

